
/*\
  /     Amfow_imi - fido-over-email mailer (c) Alex Kocharin, 2:50/13
 /      
/       This program is free software, licence is GNU GPL
\*/


class C_network
{
	private:
		int sockfd;
	public:
		bool connected;
		bool Connect(std::string host, int port);
		bool write(std::string data);
		std::string read(int size);
		std::string reads(int size);
		void Disconnect();
		~C_network();
};

bool C_network::Connect(std::string host, int port)
{
	struct hostent *he;
	struct sockaddr_in their_addr; //    
	connected = false;
	if ((he=gethostbyname(host.c_str())) == NULL) {  //   
		return false;
//		perror("gethostbyname");
//		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		return false;
//		perror("socket");
//		exit(1);
	}

	their_addr.sin_family = AF_INET;    // Host Byte Order
	their_addr.sin_port = htons(port);  // short, Network Byte Order
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(their_addr.sin_zero), 0, 8);  //   

	if (connect(sockfd, (struct sockaddr *)&their_addr,
										  sizeof(struct sockaddr)) == -1) {
		return false;
//		perror("connect");
//		exit(1);
	}
	connected = true;
	return true;
}

bool C_network::write(std::string data)
{
	return send(sockfd, data.c_str(), data.length(), 0) == -1;
}

std::string C_network::read(int size)
{
	char* buffer;
	int numbytes;
	buffer = (char*)malloc(size+1);
	if(buffer == NULL) {
		return "";
	}
	if ((numbytes=recv(sockfd, buffer, size, 0)) == -1) {
		free(buffer);
		return "";
	}
	std::string ret = "";
	for(long i=0;i<numbytes;i++) ret += buffer[i];
	free(buffer);
	return ret;
}

std::string C_network::reads(int size)
{
	char bufm;
	int numbytes = 0;
	std::string ret = "";
	for (int i=0; i<size; i++) {
		int rec = recv(sockfd, &bufm, 1, 0);
		if (rec == -1) break;
		numbytes += rec;
		ret += bufm;
		if (bufm == '\n') break;
	}
	return ret;
}

void C_network::Disconnect()
{
	if (connected) close(sockfd);
	connected = false;
}

C_network::~C_network()
{
	if (connected) close(sockfd);
}
